//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
#include <windows.h>
#include <iostream>
#include "GTAPI_FACE2.h"

std::string to_string( int x ) {
	std::string str = "";

  int length = 20;
  char* buf = new char[length + 1];
  snprintf( buf, length + 1, "%d", x );
  str = buf;
  delete[] buf;
  return str;
}

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;


void __stdcall local_CB_On_RecvConnected(int ch)
{
	sdkapp_msg* msg = new sdkapp_msg;
	msg->eventID = WM_SDKAPP_CONNECTED;
	msg->chanID = ch;

	//It is safer to post a message to Main Window instead of directly calling here as it is in low level SDK thread
	if(Form1)
		PostMessage(Form1->Handle, WM_SDKAPP_CONNECTED, 0, (LPARAM)msg);
}

void __stdcall local_CB_On_RecvOffered(int ch, const char* sCaller, const char* sCallee, const char* sDestAddr, \
		const char* sViaAddr, const char* sFromIP, unsigned short nFromPort)
{
	sdkapp_msg* msg = new sdkapp_msg;
	msg->eventID = WM_SDKAPP_OFFERED;
	msg->chanID = ch;
	msg->args[0] = sCaller;
	msg->args[1] = sCallee;
	msg->args[2] = sDestAddr;
	msg->args[3] = sViaAddr;
	msg->args[4] = sFromIP;
	msg->args[5] = to_string(nFromPort);

	//It is safer to post a message to Main Window instead of directly calling here as it is in low level SDK thread
	if(Form1)
		PostMessage(Form1->Handle, WM_SDKAPP_OFFERED, 0, (LPARAM)msg);

}

void __stdcall local_CB_On_RecvDialing(int ch, const char* sCaller, const char* sCallee)
{
	sdkapp_msg* msg = new sdkapp_msg;
	msg->eventID = WM_SDKAPP_DIALING;
	msg->chanID = ch;
	msg->args[0] = sCaller;
	msg->args[1] = sCallee;

	//It is safer to post a message to Main Window instead of directly calling here as it is in low level SDK thread
	if(Form1)
		PostMessage(Form1->Handle, WM_SDKAPP_DIALING, 0, (LPARAM)msg);
}

void __stdcall local_CB_On_RecvIdle(int ch, int code, const char* desc)
{
  	sdkapp_msg* msg = new sdkapp_msg;
	msg->eventID = WM_SDKAPP_IDLE;
	msg->chanID = ch;
	msg->args[0] = to_string(code);
	msg->args[1] = desc;

	//It is safer to post a message to Main Window instead of directly calling here as it is in low level SDK thread
	if(Form1)
		PostMessage(Form1->Handle, WM_SDKAPP_IDLE, 0, (LPARAM)msg);

}

void __stdcall local_CB_On_RecvRinging(int ch)
{
	sdkapp_msg* msg = new sdkapp_msg;
	msg->eventID = WM_SDKAPP_RINGING;
	msg->chanID = ch;

	//It is safer to post a message to Main Window instead of directly calling here as it is in low level SDK thread
	if(Form1)
		PostMessage(Form1->Handle, WM_SDKAPP_RINGING, 0, (LPARAM)msg);
}

void __stdcall local_CB_On_RecvRegStatus(int user_id, int status, int regtime)
{
	sdkapp_msg* msg = new sdkapp_msg;
	msg->eventID = WM_SDKAPP_REGSTATUS;
	msg->chanID = user_id;
	msg->args[0] = to_string(status);
	msg->args[1] = to_string(regtime);

	//It is safer to post a message to Main Window instead of directly calling here as it is in low level SDK thread
	if(Form1)
		PostMessage(Form1->Handle, WM_SDKAPP_REGSTATUS, 0, (LPARAM)msg);
}

void __stdcall local_CB_On_RecvAudioPlayDone(int ch, int doneReason, const char* dtmfBuffer)
{
	sdkapp_msg* msg = new sdkapp_msg;
	msg->eventID = WM_SDKAPP_AUDIOPLAYDONE;
	msg->chanID = ch;
	msg->args[0] = to_string(doneReason);
	msg->args[1] = dtmfBuffer;

	//It is safer to post a message to Main Window instead of directly calling here as it is in low level SDK thread
	if(Form1)
		PostMessage(Form1->Handle, WM_SDKAPP_AUDIOPLAYDONE, 0, (LPARAM)msg);
}

void __stdcall local_CB_On_RecvAudioRecordDone(int ch, int doneReason, const char* dtmfBuffer)
{
	sdkapp_msg* msg = new sdkapp_msg;
	msg->eventID = WM_SDKAPP_AUDIORECORDDONE;
	msg->chanID = ch;
	msg->args[0] = to_string(doneReason);
	msg->args[1] = dtmfBuffer;

	//It is safer to post a message to Main Window instead of directly calling here as it is in low level SDK thread
	if(Form1)
		PostMessage(Form1->Handle, WM_SDKAPP_AUDIORECORDDONE, 0, (LPARAM)msg);
}

void __stdcall local_CB_On_RecvAudioStatus(int ch, int resType, int statusCode, unsigned long bytesDone)
{
	sdkapp_msg* msg = new sdkapp_msg;
	msg->eventID = WM_SDKAPP_AUDIOSTATUS;
	msg->chanID = ch;
	msg->args[0] = to_string(resType);
	msg->args[1] = to_string(statusCode);
	msg->args[2] = to_string(bytesDone);

	//It is safer to post a message to Main Window instead of directly calling here as it is in low level SDK thread
	if(Form1)
		PostMessage(Form1->Handle, WM_SDKAPP_AUDIOSTATUS, 0, (LPARAM)msg);
}

void __stdcall local_CB_On_RecvDTMFDone(int ch, int doneReason, const char* dtmfBuf)
{
	sdkapp_msg* msg = new sdkapp_msg;
	msg->eventID = WM_SDKAPP_DTMFDONE;
	msg->chanID = ch;
	msg->args[0] = to_string(doneReason);
	msg->args[1] = dtmfBuf;

	//It is safer to post a message to Main Window instead of directly calling here as it is in low level SDK thread
	if(Form1)
		PostMessage(Form1->Handle, WM_SDKAPP_DTMFDONE, 0, (LPARAM)msg);
}

void __stdcall local_CB_On_RecvDTMFKeyDown(int ch, unsigned char keyValue, unsigned long ticks)
{
	sdkapp_msg* msg = new sdkapp_msg;
	msg->eventID = WM_SDKAPP_DTMFKEYDOWN;
	msg->chanID = ch;
	msg->args[0] = keyValue;
	msg->args[1] = to_string(ticks);

	//It is safer to post a message to Main Window instead of directly calling here as it is in low level SDK thread
	if(Form1)
		PostMessage(Form1->Handle, WM_SDKAPP_DTMFKEYDOWN, 0, (LPARAM)msg);
}

void __stdcall local_CB_On_RecvDTMFKeyUp(int ch, unsigned char keyValue, unsigned long ticks)
{
	sdkapp_msg* msg = new sdkapp_msg;
	msg->eventID = WM_SDKAPP_DTMFKEYUP;
	msg->chanID = ch;
	msg->args[0] = keyValue;
	msg->args[1] = to_string(ticks);

	//It is safer to post a message to Main Window instead of directly calling here as it is in low level SDK thread
	if(Form1)
		PostMessage(Form1->Handle, WM_SDKAPP_DTMFKEYUP, 0, (LPARAM)msg);
}

void __stdcall local_CB_On_Timer(int ch)
{
	sdkapp_msg* msg = new sdkapp_msg;
	msg->eventID = WM_SDKAPP_TIMER;
	msg->chanID = ch;

	//It is safer to post a message to Main Window instead of directly calling here as it is in low level SDK thread
	if(Form1)
		PostMessage(Form1->Handle, WM_SDKAPP_TIMER, 0, (LPARAM)msg);
}

void __stdcall local_CB_On_VoiceActivityDetected(int ch, int voice_dir, int voice_on, int level, unsigned int reserved)
{
	sdkapp_msg* msg = new sdkapp_msg;
	msg->eventID = WM_SDKAPP_VAD;
	msg->chanID = ch;
	msg->args[0] = to_string(voice_dir);
	msg->args[1] = to_string(voice_on);
	msg->args[2] = to_string(level);
	msg->args[3] = to_string(reserved);

	//It is safer to post a message to Main Window instead of directly calling here as it is in low level SDK thread
	if(Form1)
		PostMessage(Form1->Handle, WM_SDKAPP_VAD, 0, (LPARAM)msg);
}

void __stdcall local_CB_On_DetectHumanVoiceDone(int ch, int result)
{
	sdkapp_msg* msg = new sdkapp_msg;
	msg->eventID = WM_SDKAPP_DETECTHUMANVOICEDONE;
	msg->chanID = ch;
	msg->args[0] = to_string(result);

	//It is safer to post a message to Main Window instead of directly calling here as it is in low level SDK thread
	if(Form1)
		PostMessage(Form1->Handle, WM_SDKAPP_DETECTHUMANVOICEDONE, 0, (LPARAM)msg);
}

void __stdcall local_CB_On_RecvToneDetected(int ch, int freq)
{
	sdkapp_msg* msg = new sdkapp_msg;
	msg->eventID = WM_SDKAPP_TONEDETECTED;
	msg->chanID = ch;
	msg->args[0] = to_string(freq);

	//It is safer to post a message to Main Window instead of directly calling here as it is in low level SDK thread
	if(Form1)
		PostMessage(Form1->Handle, WM_SDKAPP_TONEDETECTED, 0, (LPARAM)msg);
}

//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormCreate(TObject *Sender)
{
	cfgEdit->Text = _T("c:\\sdk\\ini\\GTSIPServerApp.ini");

	cbApplicationType->ItemIndex = 0;

	btnStartSIPServer->Enabled = true;
	btnStopSIPServer->Enabled = false;

	editDTMFMaxDigits->Text = _T("0");
	editDTMFTermStr->Text = _T("");
	editDTMFTimeout->Text = _T("0");

	editSoundFile->Enabled = true;
	btnBrowseSoundFile->Enabled = true;

	btnDialChan1->Enabled = false;
	btnDialChan2->Enabled = false;
	btnDialChan3->Enabled = false;
	btnDialChan4->Enabled = false;

	editChan1Addr->Enabled = false;
	editChan2Addr->Enabled = false;
	editChan3Addr->Enabled = false;
	editChan4Addr->Enabled = false;

}
//---------------------------------------------------------------------------

void __fastcall TForm1::OnSDKAppMessage(TMessage& tmsg)
{
	sdkapp_msg* msg = (sdkapp_msg*)tmsg.LParam;
	if(!msg)
		return;

	switch(msg->eventID)
	{
		case WM_SDKAPP_OFFERED:
		On_RecvOffered(msg->chanID, msg->args[0].c_str(), msg->args[1].c_str(), msg->args[2].c_str(), msg->args[3].c_str(), msg->args[4].c_str(), atoi(msg->args[5].c_str()));
		break;
		case WM_SDKAPP_DIALING:
		On_RecvDialing(msg->chanID, msg->args[0].c_str(), msg->args[1].c_str());
		break;
		case WM_SDKAPP_RINGING:
		On_RecvRinging(msg->chanID);
		break;
		case WM_SDKAPP_CONNECTED:
		On_RecvConnected(msg->chanID);
		break;
		case WM_SDKAPP_IDLE:
		On_RecvIdle(msg->chanID, atoi(msg->args[0].c_str()), msg->args[1].c_str());
		break;
		case WM_SDKAPP_REGSTATUS:
		On_RecvRegStatus(msg->chanID, atoi(msg->args[0].c_str()), atoi(msg->args[1].c_str()));
		break;
		case WM_SDKAPP_AUDIOPLAYDONE:
		On_RecvAudioPlayDone(msg->chanID, atoi(msg->args[0].c_str()), msg->args[1].c_str());
		break;
		case WM_SDKAPP_AUDIORECORDDONE:
		On_RecvAudioRecordDone(msg->chanID, atoi(msg->args[0].c_str()), msg->args[1].c_str());
		break;
		case WM_SDKAPP_AUDIOSTATUS:
		On_RecvAudioStatus(msg->chanID, atoi(msg->args[0].c_str()), atoi(msg->args[1].c_str()), atoi(msg->args[2].c_str()));
		break;
		case WM_SDKAPP_DTMFDONE:
		On_RecvDTMFDone(msg->chanID, atoi(msg->args[0].c_str()), msg->args[1].c_str());
		break;
		case WM_SDKAPP_DTMFKEYDOWN:
		On_RecvDTMFKeyDown(msg->chanID, msg->args[0][0], atoi(msg->args[1].c_str()));
		break;
		case WM_SDKAPP_DTMFKEYUP:
		On_RecvDTMFKeyUp(msg->chanID, msg->args[0][0], atoi(msg->args[1].c_str()));
		break;
		case WM_SDKAPP_TIMER:
		OnTimer(msg->chanID);
		break;
		case WM_SDKAPP_VAD:
		On_VoiceActivityDetected(msg->chanID, atoi(msg->args[0].c_str()), atoi(msg->args[1].c_str()), atoi(msg->args[2].c_str()), atoi(msg->args[3].c_str()));
		break;
		case WM_SDKAPP_DETECTHUMANVOICEDONE:
		On_DetectHumanVoiceDone(msg->chanID, atoi(msg->args[0].c_str()));
		break;
		case WM_SDKAPP_TONEDETECTED:
		On_RecvToneDetected(msg->chanID, atoi(msg->args[0].c_str()));
		break;
	}

	delete msg;
}


void TForm1::On_RecvConnected(int ch)
{
	TButton *pButton = 0;
	TEdit *pEdit= 0;

	switch(ch)
	{
	case 0:
		pButton = btnDialChan1;
		pEdit = editChan1Addr;
		break;
	case 1:
		pButton = btnDialChan2;
		pEdit = editChan2Addr;
		break;
	case 2:
		pButton = btnDialChan3;
		pEdit = editChan3Addr;
		break;
	case 3:
		pButton = btnDialChan4;
		pEdit = editChan4Addr;
		break;
	}

	if(pButton)
	{
		pButton->Enabled = true;
		pButton->SetTextBuf(_T("Hang up"));
	}

	if(pEdit)
		pEdit->Enabled = false;

	chanState[ch] = CHAN_STATE_CONNECTED;
	/////////////////////////////////////////////////////////////////////////////
	int maxDigits = StrToInt(editDTMFMaxDigits->Text);
	int timeout = StrToInt(editDTMFTimeout->Text);

	const char* termStr = AnsiString(editDTMFTermStr->Text).c_str();

	int nSel = cbApplicationType->ItemIndex;

	if(nSel == 0) //play sound
	{
		GTAPI_Send_PlayAudio(ch, AnsiString(editSoundFile->Text).c_str(), maxDigits, termStr, timeout, 0) ;

		UnicodeString logInfo;
		logInfo.printf(_T("Connected! Playing sound %s."), editSoundFile->Text.c_str());
		Log(ch, logInfo);

		GTAPI_StartTimer(ch, 2000);
	}
	else if(nSel == 1) //record sound
	{
		char sTemp[255];
		char sTemp1[512];
		char *p = 0;
		AnsiString ansiB(editSoundFile->Text);

		strcpy(sTemp, ansiB.c_str());

		//add channel id into file name to make sure files are unique for individual channels
		p = sTemp + strlen(sTemp) - 1;
		while(*p != '.' && p > sTemp) p--;

		if(*p == '.')
		{
			*p = 0;
			p++;
			sprintf(sTemp1, "%s-%d.%s", sTemp, ch, p);
		}
		else// p == sTemp, there is no extersion
		{
			sprintf(sTemp1, "%s-%d", sTemp, ch);
		}

		GTAPI_Send_RecordAudio(ch, sTemp1, maxDigits, termStr, timeout, 0);

		UnicodeString logInfo, info1 = sTemp1;
		logInfo.printf(_T("Connected! Recording sound to %s."), info1.c_str());
		Log(ch, logInfo);

		GTAPI_StartTimer(ch, 2000);
	}
	else if(nSel == 2) //echo test
	{
		GTAPI_Send_HalfConnect(ch, ch);
		Log(ch, _T("Connected! Echo testing..."));
	}
	else if(nSel == 3) //call bridge
	{
		if(ch == 0)
		{
			Log(ch, _T("Connected! Waiting for next channel to connect."));
		}
		else if(ch == 1)
		{
			GTAPI_Send_DuplexConnect(0, 1);
			Log(0, _T("Connected! Chan 1 and 2 are connected!"));
			Log(1, _T("Connected! Chan 1 and 2 are connected!"));
		}
		else if(ch == 2)
		{
			Log(ch, _T("Connected! Waiting for next channel to connect."));
		}
		else if(ch == 3)
		{
			GTAPI_Send_DuplexConnect(2, 3);
			Log(2, _T("Connected! Chan 3 and 4 are connected!"));
			Log(3, _T("Connected! Chan 3 and 4 are connected!"));
		}
	}
	else if(nSel == 4) //DTMF detector
	{
		GTAPI_Send_EnableDTMF(ch, 0, "", 0);
		Log(ch, _T("Connected! Waiting for DTMF digits."));
	}
	else if(nSel == 5) //music on hold
	{
		AnsiString ansiB(editSoundFile->Text);
		GTAPI_Send_StartMusicOnHold(ch, ansiB.c_str(), 1, 0);

		UnicodeString logInfo;
		logInfo.printf(_T("Connected! Music on hold, playing music files in %s."), editSoundFile->Text.c_str());
		Log(ch, logInfo);
	}
	else if(nSel == 6)
	{
		GTAPI_Send_SetChanInConference(0, ch, 1);
		Log(ch, _T("Connected! In conference room"));
	}
	else if(nSel == 7)
	{
		Log(ch, _T("Connected! Detecting voice ..., please talk."));
	}
	else if(nSel == 8)
	{
		Log(ch, _T("Connected! Detecting fax ..."));

		GTAPI_Send_ClearToneList(ch);
		GTAPI_Send_AddTone(ch, 2100, 2200); //T.30 standard, callee plays 2100HZ for 2.6s-4.s,
		GTAPI_Send_AddTone(ch, 1100, 400);  //T.30 standard, caller plays 1100HZ for 500ms,
		GTAPI_Send_StartToneDetection(ch);
	}
	else if(nSel == 9)
	{
		/*GTAPI_Send_PlayAndRecordVideo(ch, AnsiString(editSoundFile->Text).c_str(), 0);

		UnicodeString logInfo;
		logInfo.Format(_T("Connected! Playing video %s."), editSoundFile->Text.c_str(), 200);
		Log(ch, logInfo); */
	}


}

void TForm1::On_RecvOffered(int ch, const char* sCaller, const char* sCallee, const char* sDestAddr, \
			const char* sViaAddr, const char* sFromIP, unsigned short nFromPort)
{
	TButton *pButton = 0;
	TEdit *pEdit= 0;

	switch(ch)
	{
	case 0:
		pButton = btnDialChan1;
		pEdit = editChan1Addr;
		break;
	case 1:
		pButton = btnDialChan2;
		pEdit = editChan2Addr;
		break;
	case 2:
		pButton = btnDialChan3;
		pEdit = editChan3Addr;
		break;
	case 3:
		pButton = btnDialChan4;
		pEdit = editChan4Addr;
		break;
	}

	if(pButton)
	{
		pButton->Enabled = true;
		pButton->SetTextBuf(_T("Hang up"));
	}

	if(pEdit)
		pEdit->Enabled = false;

	chanState[ch] = CHAN_STATE_RINGING_LOCAL;

	////////////////////////////////////////////////////////////////////////
	char sTemp[255];

	sprintf(sTemp, "New call from %s to %s.", sCaller, sCallee);

	UnicodeString logInfo = sTemp;
	Log(ch, logInfo);

	GTAPI_Send_Answer(ch);
}

void TForm1::On_RecvDialing(int ch, const char* sCaller, const char* sCallee)
{
	TButton *pButton = 0;
	TEdit *pEdit= 0;

	switch(ch)
	{
	case 0:
		pButton = btnDialChan1;
		pEdit = editChan1Addr;
		break;
	case 1:
		pButton = btnDialChan2;
		pEdit = editChan2Addr;
		break;
	case 2:
		pButton = btnDialChan3;
		pEdit = editChan3Addr;
		break;
	case 3:
		pButton = btnDialChan4;
		pEdit = editChan4Addr;
		break;
	}

	if(pButton)
	{
		pButton->Enabled = true;
		pButton->SetTextBuf(_T("Hang up"));
	}

	if(pEdit)
		pEdit->Enabled = false;

	chanState[ch] = CHAN_STATE_DIALING;
}

void TForm1::On_RecvIdle(int ch, int code, const char* desc)
{
	TButton *pButton = 0;
	TEdit *pEdit= 0;

	switch(ch)
	{
	case 0:
		pButton = btnDialChan1;
		pEdit = editChan1Addr;
		break;
	case 1:
		pButton = btnDialChan2;
		pEdit = editChan2Addr;
		break;
	case 2:
		pButton = btnDialChan3;
		pEdit = editChan3Addr;
		break;
	case 3:
		pButton = btnDialChan4;
		pEdit = editChan4Addr;
		break;
	}

	if(pButton)
	{
		pButton->Enabled = true;
		pButton->SetTextBuf(_T("Dial"));
	}

	if(pEdit)
		pEdit->Enabled = true;

	Log(ch, _T("IDLE"));

	chanState[ch] = CHAN_STATE_IDLE;
}

void TForm1::On_RecvRinging(int ch)
{
	TButton *pButton = 0;
	TEdit *pEdit= 0;

	switch(ch)
	{
	case 0:
		pButton = btnDialChan1;
		pEdit = editChan1Addr;
		break;
	case 1:
		pButton = btnDialChan2;
		pEdit = editChan2Addr;
		break;
	case 2:
		pButton = btnDialChan3;
		pEdit = editChan3Addr;
		break;
	case 3:
		pButton = btnDialChan4;
		pEdit = editChan4Addr;
		break;
	}

	if(pButton)
	{
		pButton->Enabled = true;
		pButton->SetTextBuf(_T("Hang up"));
	}

	if(pEdit)
		pEdit->Enabled = false;

	chanState[ch] = CHAN_STATE_RINGING_REMOTE;
}

void TForm1::On_RecvRegStatus(int user_id, int status, int regtime)
{
	char sTemp[100];
	if(status)
	{
		sprintf(sTemp, "RAD Studio XE8 C++ Builder Sample - Server Sample --- %s", GTAPI_CFG_GetValue("gtsrv.sip.reg1.authorization", ""));
	}
	else
	{
		sprintf(sTemp, "RAD Studio XE8 C++ Builder Sample - Server Sample --- %s XXX!",  GTAPI_CFG_GetValue("gtsrv.sip.reg1.authorization", ""));
	}


	Caption = sTemp;
}

void TForm1::On_RecvAudioPlayDone(int ch, int doneReason, const char* dtmfBuffer)
{

}

void TForm1::On_RecvAudioRecordDone(int ch, int doneReason, const char* dtmfBuffer)
{

}

void TForm1::On_RecvAudioStatus(int ch, int resType, int statusCode, unsigned long bytesDone)
{
	int nSel = cbApplicationType->ItemIndex;

	if(chanState[ch] != CHAN_STATE_CONNECTED)
		return;

	if(nSel == 0)
	{
		UnicodeString sLogInfo;
		sLogInfo.printf(_T("Connected! Playing sound ... Offset bytes: %d"), bytesDone);
		Log(ch, sLogInfo);
	}
	else if(nSel == 1)
	{
		char sTemp[255];
		char sTemp1[512];
		char *p = 0;

		AnsiString ansiB(editSoundFile->Text);

		strcpy(sTemp, ansiB.c_str());

		//add channel id into file name to make sure files are unique for individual channels
		p = sTemp + strlen(sTemp) - 1;
		while(*p != '.' && p > sTemp) p--;

		if(*p == '.')
		{
			*p = 0;
			p++;
			sprintf(sTemp1, "%s-%d.%s", sTemp, ch, p);
		}
		else// p == sTemp, there is no extersion
		{
			sprintf(sTemp1, "%s-%d", sTemp, ch);
		}

		UnicodeString fn1 = sTemp1;

		UnicodeString sLogInfo;
		sLogInfo.printf(_T("Connected! Recording sound ... Offset bytes: %d"), bytesDone);
		Log(ch, sLogInfo);

	}
}

void TForm1::On_RecvDTMFDone(int ch, int reason, const char* dtmfBuf)
{

}

void TForm1::On_RecvDTMFKeyDown(int ch, unsigned char keyValue, unsigned long ticks)
{
	if(chanState[ch] != CHAN_STATE_CONNECTED)
		return;

	UnicodeString logInfo;
	logInfo.printf(_T("Connected! %c key down!"), keyValue);
	Log(ch, logInfo);
}

void TForm1::On_RecvDTMFKeyUp(int ch, unsigned char keyValue, unsigned long ticks)
{
	if(chanState[ch] != CHAN_STATE_CONNECTED)
		return;

	UnicodeString logInfo;
	logInfo.printf(_T("Connected! %c key up!"), keyValue);
	Log(ch, logInfo);
}

void TForm1::On_VoiceActivityDetected(int ch, int voice_dir, int voice_on, int level, unsigned int reserved)
{
	UnicodeString logInfo;

	if(chanState[ch] != CHAN_STATE_CONNECTED)
		return;

	int nSel = cbApplicationType->ItemIndex;

	if(nSel == 7 && voice_dir == 1)
	{
		if(voice_on)
			logInfo = _T("Connected! Voice is on.");
		else
			logInfo = _T("Connected! Voice is off.");

		Log(ch, logInfo);
	}
}

void TForm1::OnTimer(int ch)
{
	int nSel = cbApplicationType->ItemIndex;
	if(nSel == 0 || nSel == 1)
	{
		if(chanState[ch] == CHAN_STATE_CONNECTED)
		{
			GTAPI_Send_GetAudioStatus(ch);
			GTAPI_StartTimer(ch, 2000);
		}
	}
}

void TForm1::On_RecvToneDetected(int ch, int freq)
{
	UnicodeString logInfo;
	int nSel = cbApplicationType->ItemIndex;

	if(chanState[ch] != CHAN_STATE_CONNECTED)
		return;

	if(nSel == 8)
	{
		logInfo.printf(_T("Connected! Fax tone detected. Frequency: %d"), freq);
		Log(ch, logInfo);

		GTAPI_Send_StopToneDetection(ch);
	}
}

void TForm1::On_DetectHumanVoiceDone(int ch, int result)
{

}

//////////////////////////////////////////////////////////////////////////////////////////

void TForm1::Log(int ch, UnicodeString info)
{
	switch(ch)
	{
	case 0:
		editChan1Status->Text = info;
		break;
	case 1:
		editChan2Status->Text = info;
		break;
	case 2:
		editChan3Status->Text = info;
		break;
	case 3:
		editChan4Status->Text = info;
		break;
	}
}

void TForm1::InitSIPServer(int app, const char* iniCfgFile)
{
	appType = app;

	GTAPI_Create_Env();

	GTAPI_SetMainWnd(Handle);

	GTAPI_CFG_SetValue("gtsrv.config.filename", iniCfgFile);

	GTAPI_CFG_SetValue("gtsrv.sip.server.model", "1"); //client phone

	GTAPI_CFG_SetValue("gtsrv.sip.callcontrol.auto.acceptcall", "1");
	GTAPI_CFG_SetValue("gtsrv.sip.callcontrol.auto.ringcall", "0");

	//GTAPI_CFG_SetValue("gtsrv.sip.proxy.sites.num", "1");
	//GTAPI_CFG_SetValue("gtsrv.sip.proxy.site1.domain", "");
	//GTAPI_CFG_SetValue("gtsrv.sip.proxy.site1.recordroute", "1");
	//GTAPI_CFG_SetValue("gtsrv.sip.proxy.site1.udp.relay", "0");

	if(appType == 6)
		GTAPI_CFG_SetValue("gtsrv.sip.conference.room", "1");
	else
		GTAPI_CFG_SetValue("gtsrv.sip.conference.room", "0");

	if(appType == 7)
		GTAPI_CFG_SetValue("gtsrv.sip.on.in.vad", "1");
	else
		GTAPI_CFG_SetValue("gtsrv.sip.on.in.vad", "0");

	if(appType == 8)
		//set RTP access
		GTAPI_CFG_SetValue("gtsrv.sip.on.rtp.packet", "1");
	else
		GTAPI_CFG_SetValue("gtsrv.sip.on.rtp.packet", "0");

	GTAPI_SetCB_On_RecvConnected(local_CB_On_RecvConnected);
	GTAPI_SetCB_On_RecvOffered(local_CB_On_RecvOffered);
	GTAPI_SetCB_On_RecvDialing(local_CB_On_RecvDialing);
	GTAPI_SetCB_On_RecvIdle(local_CB_On_RecvIdle);
	GTAPI_SetCB_On_RecvRinging(local_CB_On_RecvRinging);
	GTAPI_SetCB_On_RecvRegStatus(local_CB_On_RecvRegStatus);


	GTAPI_SetCB_On_RecvAudioPlayDone(local_CB_On_RecvAudioPlayDone);
	GTAPI_SetCB_On_RecvAudioRecordDone(local_CB_On_RecvAudioRecordDone);
	GTAPI_SetCB_On_RecvAudioStatus(local_CB_On_RecvAudioStatus);

	GTAPI_SetCB_On_RecvDTMFDone(local_CB_On_RecvDTMFDone);
	GTAPI_SetCB_On_RecvDTMFKeyDown(local_CB_On_RecvDTMFKeyDown);
	GTAPI_SetCB_On_RecvDTMFKeyUp(local_CB_On_RecvDTMFKeyUp);

	GTAPI_SetCB_On_Timer(local_CB_On_Timer);

	GTAPI_SetCB_On_VoiceActivityDetected(local_CB_On_VoiceActivityDetected);
	GTAPI_SetCB_On_DetectHumanVoiceDone(local_CB_On_DetectHumanVoiceDone);
	GTAPI_SetCB_On_RecvToneDetected(local_CB_On_RecvToneDetected);

	if(!GTAPI_StartServer())
	{
		MessageBox(Handle, _T("GTAPI_StartServer Failed! Please check if SIP port is being used by another application!"), _T("Error"), MB_OK);
		//CloseWindow(Handle);
		Close();
	}

	GTAPI_Send_GetRegStatus(0);

	//If m_pEnv.GetDetectedNATType() >= 12 And m_pEnv.CFG_GetIntValue("gtsrv.sip.use.nat.addr", 0) = 0 Then
	//MessageBox.Show("You have a blocked network. You may not be able to make Internet calls. Please config your network or firewall properly, then try again.")
	//End If

	if(appType == 6)
	{
		//conference call
		GTAPI_Send_StartConference(0);
	}

	chanState = new ChanStatus[GTAPI_GetChannelCount()];

	for(int i=0; i<GTAPI_GetChannelCount(); i++)
	{
		chanState[i] = CHAN_STATE_IDLE;
		Log(i, _T("IDLE"));
	}

}

void TForm1::FreeSIPServer()
{
	if(appType == 6)
		GTAPI_Send_StopConference(0);

	GTAPI_StopServer();

	GTAPI_Destroy_Env();

	delete []chanState;
}

//---------------------------------------------------------------------------
void __fastcall TForm1::btnDialClick(TObject *Sender)
{
	//char sTemp1[256];

	//m_btnDial.GetWindowText(sTemp, 128);

	//sprintf(sTemp1, "<sip:%s>", sTemp);

	GTAPI_Send_Make(0, "<sip:8888@pcbest.net>", "");
}
//---------------------------------------------------------------------------

void __fastcall TForm1::btnHangupClick(TObject *Sender)
{
	GTAPI_Send_HangUp(0, 0, "");
}
//---------------------------------------------------------------------------

void TForm1::PressDialOrHangup(int ch, TButton* pButton, TEdit* pEdit)
{
	char s[256];
	char sTemp[256];

	memset(s, 0, 256);
	memset(sTemp, 0, 256);

	GetWindowTextA(pButton->Handle, s, 255);

	if(!strcmp(s, "Hang up"))
	{
		GTAPI_Send_HangUp(ch, 0, "");
		return;
	}

	GetWindowTextA(pEdit->Handle, s, 255);

	if(!*s) return;

	if(strstr(s, "sip:") == s) //there are NOT '<' and '>'
	{
		sprintf(sTemp, "<%s>", s);
	}
	else if(strstr(s, "<sip:") == s) //there are '<' and '>'
	{
		sprintf(sTemp, "%s", s);
	}
	else if(strchr(s, '@')) //there is '@' but without 'sip:'
	{
		sprintf(sTemp, "<sip:%s>", s);
	}
	else //there is not '@', and no 'sip:'
	{
		if(*GTAPI_CFG_GetValue("gtsrv.sip.reg1.domain", ""))
		{
			sprintf(sTemp, "<sip:%s@%s>", s, GTAPI_CFG_GetValue("gtsrv.sip.reg1.domain", ""));
		}
		else
		{
			//there is no sip account
			//cannot call, just return
			return;
		}
	}

	GTAPI_Send_Make(ch, sTemp, "");

}

void __fastcall TForm1::cbApplicationTypeChange(TObject *Sender)
{
	int nSel = cbApplicationType->ItemIndex;

	//Log(0, UnicodeString(nSel));

	if(nSel == 0 || nSel == 1)
	{
		editSoundFile->Enabled = true;
		btnBrowseSoundFile->Enabled = true;

		editDTMFMaxDigits->Enabled = true;
		editDTMFTermStr->Enabled = true;
		editDTMFTimeout->Enabled = true;
	}
	else if(nSel == 5)
	{
		editSoundFile->Enabled = true;
		btnBrowseSoundFile->Enabled = true;

		editDTMFMaxDigits->Enabled = false;
		editDTMFTermStr->Enabled = false;
		editDTMFTimeout->Enabled = false;
	}
	else if(nSel == 9)
	{
		editSoundFile->Enabled = true;
		btnBrowseSoundFile->Enabled = true;
	}
	else
	{
		editSoundFile->Enabled = false;
		btnBrowseSoundFile->Enabled = false;

		editDTMFMaxDigits->Enabled = false;
		editDTMFTermStr->Enabled = false;
		editDTMFTimeout->Enabled = false;
	}
}
//---------------------------------------------------------------------------

void __fastcall TForm1::btnBrowseSoundFileClick(TObject *Sender)
{
	int nSel = cbApplicationType->ItemIndex;

	if(nSel == 0)
	{
		if( OpenDialog1->Execute() == True )
		{
			editSoundFile->Text = OpenDialog1->FileName;
		}
	}
	else if(nSel == 1)
	{
		if(SaveDialog1->Execute() == True )
		{
			editSoundFile->Text = SaveDialog1->FileName;
		}
	}
	else if(nSel == 5)
	{
		if( OpenDialog1->Execute() == True )
		{
			editSoundFile->Text = OpenDialog1->GetNamePath();
		}
	}
	else if(nSel == 9)
	{
		if( OpenDialog1->Execute() == True )
		{
			editSoundFile->Text = OpenDialog1->FileName;
		}
	}
}
//---------------------------------------------------------------------------


void __fastcall TForm1::btnStartSIPServerClick(TObject *Sender)
{
	int nSel = cbApplicationType->ItemIndex;

	if (FileExists(cfgEdit->Text) == false)
	{
		//MessageBox("Config File doesn't exist!", "ERROR!");

		ShowMessage("Config File doesn't exist!");
		return;
	}

	cbApplicationType->Enabled = false;

	editSoundFile->Enabled = false;
	btnBrowseSoundFile->Enabled = false;

	editDTMFMaxDigits->Enabled = false;
	editDTMFTermStr->Enabled = false;
	editDTMFTimeout->Enabled = false;

	btnStartSIPServer->Enabled = false;
	btnStopSIPServer->Enabled = true;
	btnExit->Enabled = false;

	btnDialChan1->Enabled = true;
	btnDialChan2->Enabled = true;
	btnDialChan3->Enabled = true;
	btnDialChan4->Enabled = true;

	editChan1Addr->Enabled = true;
	editChan2Addr->Enabled = true;
	editChan3Addr->Enabled = true;
	editChan4Addr->Enabled = true;


	// first convert to AnsiString instead of Unicode.
	AnsiString ansiB(cfgEdit->Text);

	// allocate enough memory for your char array (and the null terminator)
	char* str = new char[ansiB.Length()+1];

	// copy the contents of the AnsiString into your char array
	strcpy(str, ansiB.c_str());

	InitSIPServer(nSel, str);

	delete str;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::btnStopSIPServerClick(TObject *Sender)
{
	cbApplicationType->Enabled = true;

	int nSel = cbApplicationType->ItemIndex;

	if(nSel == 0 || nSel == 1)
	{
		editSoundFile->Enabled = true;
		btnBrowseSoundFile->Enabled = true;

		editDTMFMaxDigits->Enabled = true;
		editDTMFTermStr->Enabled = true;
		editDTMFTimeout->Enabled = true;
	}
	else if(nSel == 5)
	{
		editSoundFile->Enabled = true;
		btnBrowseSoundFile->Enabled = true;

		editDTMFMaxDigits->Enabled = false;
		editDTMFTermStr->Enabled = false;
		editDTMFTimeout->Enabled = false;
	}
	else if(nSel == 9)
	{
		editSoundFile->Enabled = true;
		btnBrowseSoundFile->Enabled = true;
	}
	else
	{
		editSoundFile->Enabled = false;
		btnBrowseSoundFile->Enabled = false;

		editDTMFMaxDigits->Enabled = false;
		editDTMFTermStr->Enabled = false;
		editDTMFTimeout->Enabled = false;
	}

	btnStartSIPServer->Enabled = true;
	btnStopSIPServer->Enabled = false;
	btnExit->Enabled = true;

	btnDialChan1->Enabled = false;
	btnDialChan2->Enabled = false;
	btnDialChan3->Enabled = false;
	btnDialChan4->Enabled = false;

	editChan1Addr->Enabled = false;
	editChan2Addr->Enabled = false;
	editChan3Addr->Enabled = false;
	editChan4Addr->Enabled = false;

	FreeSIPServer();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::btnDialChan1Click(TObject *Sender)
{
	TButton *pButton = btnDialChan1;
	TEdit *pEdit = editChan1Addr;

	PressDialOrHangup(0, pButton, pEdit);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::btnDialChan2Click(TObject *Sender)
{
	TButton *pButton = btnDialChan2;
	TEdit *pEdit = editChan2Addr;

	PressDialOrHangup(1, pButton, pEdit);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::btnDialChan3Click(TObject *Sender)
{
	TButton *pButton = btnDialChan3;
	TEdit *pEdit = editChan3Addr;

	PressDialOrHangup(2, pButton, pEdit);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::btnDialChan4Click(TObject *Sender)
{
	TButton *pButton = btnDialChan4;
	TEdit *pEdit = editChan4Addr;

	PressDialOrHangup(3, pButton, pEdit);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::browseBtnClick(TObject *Sender)
{
	if( OpenDialog2->Execute() == True )
	{
		cfgEdit->Text = OpenDialog2->FileName;
	}
}
//---------------------------------------------------------------------------

void __fastcall TForm1::btnExitClick(TObject *Sender)
{
	Close();
}
//---------------------------------------------------------------------------

