//---------------------------------------------------------------------------

#ifndef Unit1H
#define Unit1H
//---------------------------------------------------------------------------
#include <System.Classes.hpp>
#include <Vcl.Controls.hpp>
#include <Vcl.StdCtrls.hpp>
#include <Vcl.Forms.hpp>
#include <Vcl.Dialogs.hpp>
#include <string>

using namespace std;

//---------------------------------------------------------------------------
//#define WM_USER        								0x0400
#define WM_SDKAPP_BASE 								(WM_USER+0x100)
#define WM_SDKAPP_OFFERED 							WM_SDKAPP_BASE+1
#define WM_SDKAPP_DIALING 							WM_SDKAPP_BASE+2
#define WM_SDKAPP_RINGING 							WM_SDKAPP_BASE+3
#define WM_SDKAPP_CONNECTED							WM_SDKAPP_BASE+4
#define WM_SDKAPP_IDLE								WM_SDKAPP_BASE+5
#define WM_SDKAPP_REGSTATUS							WM_SDKAPP_BASE+6
#define WM_SDKAPP_AUDIOPLAYDONE						WM_SDKAPP_BASE+7
#define WM_SDKAPP_AUDIORECORDDONE					WM_SDKAPP_BASE+8
#define WM_SDKAPP_AUDIOSTATUS						WM_SDKAPP_BASE+9
#define WM_SDKAPP_DTMFDONE							WM_SDKAPP_BASE+10
#define WM_SDKAPP_DTMFKEYDOWN						WM_SDKAPP_BASE+11
#define WM_SDKAPP_DTMFKEYUP							WM_SDKAPP_BASE+12
#define WM_SDKAPP_TIMER                             WM_SDKAPP_BASE+13
#define WM_SDKAPP_VAD                             	WM_SDKAPP_BASE+14
#define WM_SDKAPP_DETECTHUMANVOICEDONE              WM_SDKAPP_BASE+15
#define WM_SDKAPP_TONEDETECTED              		WM_SDKAPP_BASE+16


struct sdkapp_msg
{
	int eventID;
	int chanID;
	std::string args[20];
};

enum ChanStatus
{
	CHAN_STATE_IDLE,
	CHAN_STATE_DIALING,
	CHAN_STATE_RINGING_REMOTE,
	CHAN_STATE_RINGING_LOCAL,
	CHAN_STATE_CONNECTED
};

//---------------------------------------------------------------------------
class TForm1 : public TForm
{
__published:	// IDE-managed Components
	TGroupBox *GroupBox1;
	TButton *browseBtn;
	TEdit *cfgEdit;
	TLabel *Label1;
	TGroupBox *GroupBox2;
	TComboBox *cbApplicationType;
	TLabel *Label2;
	TLabel *Label3;
	TLabel *Label4;
	TLabel *Label5;
	TLabel *Label6;
	TLabel *Label7;
	TLabel *Label8;
	TLabel *Label9;
	TLabel *Label10;
	TGroupBox *GroupBox3;
	TEdit *editSoundFile;
	TButton *btnBrowseSoundFile;
	TLabel *Label11;
	TGroupBox *GroupBox4;
	TLabel *Label12;
	TEdit *editDTMFMaxDigits;
	TLabel *Label13;
	TEdit *editDTMFTermStr;
	TLabel *Label14;
	TEdit *editDTMFTimeout;
	TGroupBox *GroupBox5;
	TLabel *Label15;
	TEdit *editChan1Status;
	TButton *btnDialChan1;
	TEdit *editChan1Addr;
	TLabel *Label16;
	TEdit *editChan2Status;
	TButton *btnDialChan2;
	TEdit *editChan2Addr;
	TLabel *Label17;
	TEdit *editChan3Status;
	TButton *btnDialChan3;
	TEdit *editChan3Addr;
	TLabel *Label18;
	TEdit *editChan4Status;
	TButton *btnDialChan4;
	TEdit *editChan4Addr;
	TButton *btnStartSIPServer;
	TButton *btnStopSIPServer;
	TButton *btnExit;
	TOpenDialog *OpenDialog1;
	TSaveDialog *SaveDialog1;
	TOpenDialog *OpenDialog2;
	void __fastcall FormCreate(TObject *Sender);
	void __fastcall btnDialClick(TObject *Sender);
	void __fastcall btnHangupClick(TObject *Sender);
	void __fastcall cbApplicationTypeChange(TObject *Sender);
	void __fastcall btnBrowseSoundFileClick(TObject *Sender);
	void __fastcall btnStartSIPServerClick(TObject *Sender);
	void __fastcall btnStopSIPServerClick(TObject *Sender);
	void __fastcall btnDialChan1Click(TObject *Sender);
	void __fastcall btnDialChan2Click(TObject *Sender);
	void __fastcall btnDialChan3Click(TObject *Sender);
	void __fastcall btnDialChan4Click(TObject *Sender);
	void __fastcall browseBtnClick(TObject *Sender);
	void __fastcall btnExitClick(TObject *Sender);
private:    // User declarations
	void __fastcall OnSDKAppMessage(TMessage&);

public:		// User declarations
	__fastcall TForm1(TComponent* Owner);
    BEGIN_MESSAGE_MAP
	  VCL_MESSAGE_HANDLER(WM_SDKAPP_OFFERED, TMessage, OnSDKAppMessage);
	  VCL_MESSAGE_HANDLER(WM_SDKAPP_DIALING, TMessage, OnSDKAppMessage);
	  VCL_MESSAGE_HANDLER(WM_SDKAPP_RINGING, TMessage, OnSDKAppMessage);
	  VCL_MESSAGE_HANDLER(WM_SDKAPP_CONNECTED, TMessage, OnSDKAppMessage);
	  VCL_MESSAGE_HANDLER(WM_SDKAPP_IDLE, TMessage, OnSDKAppMessage);
	  VCL_MESSAGE_HANDLER(WM_SDKAPP_REGSTATUS, TMessage, OnSDKAppMessage);
	  VCL_MESSAGE_HANDLER(WM_SDKAPP_AUDIOPLAYDONE, TMessage, OnSDKAppMessage);
	  VCL_MESSAGE_HANDLER(WM_SDKAPP_AUDIORECORDDONE, TMessage, OnSDKAppMessage);
	  VCL_MESSAGE_HANDLER(WM_SDKAPP_AUDIOSTATUS, TMessage, OnSDKAppMessage);
	  VCL_MESSAGE_HANDLER(WM_SDKAPP_DTMFDONE, TMessage, OnSDKAppMessage);
	  VCL_MESSAGE_HANDLER(WM_SDKAPP_DTMFKEYDOWN, TMessage, OnSDKAppMessage);
	  VCL_MESSAGE_HANDLER(WM_SDKAPP_DTMFKEYUP, TMessage, OnSDKAppMessage);
	  VCL_MESSAGE_HANDLER(WM_SDKAPP_TIMER, TMessage, OnSDKAppMessage);
	  VCL_MESSAGE_HANDLER(WM_SDKAPP_VAD, TMessage, OnSDKAppMessage);
	  VCL_MESSAGE_HANDLER(WM_SDKAPP_DETECTHUMANVOICEDONE, TMessage, OnSDKAppMessage);
	  VCL_MESSAGE_HANDLER(WM_SDKAPP_TONEDETECTED, TMessage, OnSDKAppMessage);
	END_MESSAGE_MAP(TForm)

	void On_RecvConnected(int ch);
	void On_RecvOffered(int ch, const char* sCaller, const char* sCallee, const char* sDestAddr, \
			const char* sViaAddr, const char* sFromIP, unsigned short nFromPort);
	void On_RecvDialing(int ch, const char* sCaller, const char* sCallee);
	void On_RecvIdle(int ch, int code, const char* desc);
	void On_RecvRinging(int ch);
	void On_RecvRegStatus(int user_id, int status, int regtime);

	void On_RecvAudioPlayDone(int ch, int doneReason, const char* dtmfBuffer);
	void On_RecvAudioRecordDone(int ch, int doneReason, const char* dtmfBuffer);
	void On_RecvAudioStatus(int ch, int resType, int statusCode, unsigned long bytesDone);
	void On_RecvDTMFDone(int ch, int reason, const char* dtmfBuf);
	void On_RecvDTMFKeyDown(int ch, unsigned char keyValue, unsigned long ticks);
	void On_RecvDTMFKeyUp(int ch, unsigned char keyValue, unsigned long ticks);

	void On_VoiceActivityDetected(int ch, int voice_dir, int voice_on, int level, unsigned int reserved);
	void OnTimer(int ch);
	void On_RecvToneDetected(int ch, int freq);
	void On_DetectHumanVoiceDone(int ch, int result);

public:
	int appType;

	//local state machine
	ChanStatus *chanState;

	void InitSIPServer(int app, const char* iniCfgFile);
	void FreeSIPServer();
	void PressDialOrHangup(int ch, TButton* pButton, TEdit* pEdit);
    void Log(int ch, UnicodeString info);
};
//---------------------------------------------------------------------------
extern PACKAGE TForm1 *Form1;
//---------------------------------------------------------------------------


//----------------------------------------------------------------------------
#endif
