//---------------------------------------------------------------------------

#ifndef Unit1H
#define Unit1H
//---------------------------------------------------------------------------
#include <System.Classes.hpp>
#include <Vcl.Controls.hpp>
#include <Vcl.StdCtrls.hpp>
#include <Vcl.Forms.hpp>
#include <string>

using namespace std;

//---------------------------------------------------------------------------
//#define WM_USER        								0x0400
#define WM_SDKAPP_BASE 								(WM_USER+0x100)
#define WM_SDKAPP_OFFERED 							WM_SDKAPP_BASE+1
#define WM_SDKAPP_DIALING 							WM_SDKAPP_BASE+2
#define WM_SDKAPP_RINGING 							WM_SDKAPP_BASE+3
#define WM_SDKAPP_CONNECTED							WM_SDKAPP_BASE+4
#define WM_SDKAPP_IDLE								WM_SDKAPP_BASE+5
#define WM_SDKAPP_REGSTATUS							WM_SDKAPP_BASE+6

struct sdkapp_msg
{
	int eventID;
	int chanID;
	std::string args[20];
};

//---------------------------------------------------------------------------
class TForm1 : public TForm
{
__published:	// IDE-managed Components
	TButton *btnDial;
	TMemo *Memo1;
	TButton *btnHangup;
	TEdit *Edit1;
	void __fastcall FormCreate(TObject *Sender);
	void __fastcall btnDialClick(TObject *Sender);
	void __fastcall FormDestroy(TObject *Sender);
	void __fastcall btnHangupClick(TObject *Sender);
private:    // User declarations
	void __fastcall OnSDKAppMessage(TMessage&);

public:		// User declarations
	__fastcall TForm1(TComponent* Owner);
    BEGIN_MESSAGE_MAP
	  VCL_MESSAGE_HANDLER(WM_SDKAPP_OFFERED, TMessage, OnSDKAppMessage);
	  VCL_MESSAGE_HANDLER(WM_SDKAPP_DIALING, TMessage, OnSDKAppMessage);
	  VCL_MESSAGE_HANDLER(WM_SDKAPP_RINGING, TMessage, OnSDKAppMessage);
	  VCL_MESSAGE_HANDLER(WM_SDKAPP_CONNECTED, TMessage, OnSDKAppMessage);
	  VCL_MESSAGE_HANDLER(WM_SDKAPP_IDLE, TMessage, OnSDKAppMessage);
	  VCL_MESSAGE_HANDLER(WM_SDKAPP_REGSTATUS, TMessage, OnSDKAppMessage);
	END_MESSAGE_MAP(TForm)

	void On_RecvConnected(int ch);
	void On_RecvOffered(int ch, const char* sCaller, const char* sCallee, const char* sDestAddr, \
			const char* sViaAddr, const char* sFromIP, unsigned short nFromPort);
	void On_RecvDialing(int ch, const char* sCaller, const char* sCallee);
	void On_RecvIdle(int ch, int code, const char* desc);
	void On_RecvRinging(int ch);
	void On_RecvRegStatus(int user_id, int status, int regtime);
};
//---------------------------------------------------------------------------
extern PACKAGE TForm1 *Form1;
//---------------------------------------------------------------------------


//----------------------------------------------------------------------------
#endif
